;;; thingatpt-before-after.el   --- more th-at-point edit functions

;; Version: 1.13

;; Copyright (C) 2006, 2007, 2008, 2009 Andreas Roehler, unless
;; indicated otherwise

;; Author: Andreas Roehler <andreas.roehler@easy-emacs.de>, unless
;; indicated otherwise

;; Keywords: convenience

;; This file is free software; you can redistribute it

;; and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2, or (at your option) any later version.

;; This file is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with GNU Emacs; see the file COPYING.  If not, write to
;; the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301, USA.

;;; Commentary:

;; Information is given with thingatpt-utils-base.el

(require 'thingatpt-utils-base)



;;;###autoload
(defun alnum-before-pt (&optional arg) 
  "Returns alnum before point if any, nil otherwise"
  (interactive "p")
  (th-before 'alnum arg))

;;;###autoload
(defun bounds-of-alnum-before-pt (&optional arg) 
  "Returns bounds of alnum before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'alnum arg))

;;;###autoload
(defun alnum-after-pt (&optional arg) 
  "Returns alnum after point if any, nil otherwise"
  (interactive "p")
  (th-after 'alnum arg))

;;;###autoload
(defun bounds-of-alnum-after-pt (&optional arg) 
  "Returns bounds of alnum after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'alnum arg))


;;;###autoload
(defun alpha-before-pt (&optional arg) 
  "Returns alpha before point if any, nil otherwise"
  (interactive "p")
  (th-before 'alpha arg))

;;;###autoload
(defun bounds-of-alpha-before-pt (&optional arg) 
  "Returns bounds of alpha before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'alpha arg))

;;;###autoload
(defun alpha-after-pt (&optional arg) 
  "Returns alpha after point if any, nil otherwise"
  (interactive "p")
  (th-after 'alpha arg))

;;;###autoload
(defun bounds-of-alpha-after-pt (&optional arg) 
  "Returns bounds of alpha after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'alpha arg))


;;;###autoload
(defun angled-no-nest-before-pt (&optional arg) 
  "Returns angled-no-nest before point if any, nil otherwise"
  (interactive "p")
  (th-before 'angled-no-nest arg))

;;;###autoload
(defun bounds-of-angled-no-nest-before-pt (&optional arg) 
  "Returns bounds of angled-no-nest before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'angled-no-nest arg))

;;;###autoload
(defun angled-no-nest-after-pt (&optional arg) 
  "Returns angled-no-nest after point if any, nil otherwise"
  (interactive "p")
  (th-after 'angled-no-nest arg))

;;;###autoload
(defun bounds-of-angled-no-nest-after-pt (&optional arg) 
  "Returns bounds of angled-no-nest after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'angled-no-nest arg))


;;;###autoload
(defun angled-greater-before-pt (&optional arg) 
  "Returns angled-greater before point if any, nil otherwise"
  (interactive "p")
  (th-before 'angled-greater arg))

;;;###autoload
(defun bounds-of-angled-greater-before-pt (&optional arg) 
  "Returns bounds of angled-greater before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'angled-greater arg))

;;;###autoload
(defun angled-greater-after-pt (&optional arg) 
  "Returns angled-greater after point if any, nil otherwise"
  (interactive "p")
  (th-after 'angled-greater arg))

;;;###autoload
(defun bounds-of-angled-greater-after-pt (&optional arg) 
  "Returns bounds of angled-greater after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'angled-greater arg))


;;;###autoload
(defun angled-lower-before-pt (&optional arg) 
  "Returns angled-lower before point if any, nil otherwise"
  (interactive "p")
  (th-before 'angled-lower arg))

;;;###autoload
(defun bounds-of-angled-lower-before-pt (&optional arg) 
  "Returns bounds of angled-lower before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'angled-lower arg))

;;;###autoload
(defun angled-lower-after-pt (&optional arg) 
  "Returns angled-lower after point if any, nil otherwise"
  (interactive "p")
  (th-after 'angled-lower arg))

;;;###autoload
(defun bounds-of-angled-lower-after-pt (&optional arg) 
  "Returns bounds of angled-lower after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'angled-lower arg))


;;;###autoload
(defun ascii-before-pt (&optional arg) 
  "Returns ascii before point if any, nil otherwise"
  (interactive "p")
  (th-before 'ascii arg))

;;;###autoload
(defun bounds-of-ascii-before-pt (&optional arg) 
  "Returns bounds of ascii before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'ascii arg))

;;;###autoload
(defun ascii-after-pt (&optional arg) 
  "Returns ascii after point if any, nil otherwise"
  (interactive "p")
  (th-after 'ascii arg))

;;;###autoload
(defun bounds-of-ascii-after-pt (&optional arg) 
  "Returns bounds of ascii after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'ascii arg))


;;;###autoload
(defun backslashed-before-pt (&optional arg) 
  "Returns backslashed before point if any, nil otherwise"
  (interactive "p")
  (th-before 'backslashed arg))

;;;###autoload
(defun bounds-of-backslashed-before-pt (&optional arg) 
  "Returns bounds of backslashed before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'backslashed arg))

;;;###autoload
(defun backslashed-after-pt (&optional arg) 
  "Returns backslashed after point if any, nil otherwise"
  (interactive "p")
  (th-after 'backslashed arg))

;;;###autoload
(defun bounds-of-backslashed-after-pt (&optional arg) 
  "Returns bounds of backslashed after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'backslashed arg))


;;;###autoload
(defun blank-before-pt (&optional arg) 
  "Returns blank before point if any, nil otherwise"
  (interactive "p")
  (th-before 'blank arg))

;;;###autoload
(defun bounds-of-blank-before-pt (&optional arg) 
  "Returns bounds of blank before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'blank arg))

;;;###autoload
(defun blank-after-pt (&optional arg) 
  "Returns blank after point if any, nil otherwise"
  (interactive "p")
  (th-after 'blank arg))

;;;###autoload
(defun bounds-of-blank-after-pt (&optional arg) 
  "Returns bounds of blank after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'blank arg))


;;;###autoload
(defun braced-before-pt (&optional arg) 
  "Returns braced before point if any, nil otherwise"
  (interactive "p")
  (th-before 'braced arg))

;;;###autoload
(defun bounds-of-braced-before-pt (&optional arg) 
  "Returns bounds of braced before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'braced arg))

;;;###autoload
(defun braced-after-pt (&optional arg) 
  "Returns braced after point if any, nil otherwise"
  (interactive "p")
  (th-after 'braced arg))

;;;###autoload
(defun bounds-of-braced-after-pt (&optional arg) 
  "Returns bounds of braced after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'braced arg))


;;;###autoload
(defun bracketed-before-pt (&optional arg) 
  "Returns bracketed before point if any, nil otherwise"
  (interactive "p")
  (th-before 'bracketed arg))

;;;###autoload
(defun bounds-of-bracketed-before-pt (&optional arg) 
  "Returns bounds of bracketed before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'bracketed arg))

;;;###autoload
(defun bracketed-after-pt (&optional arg) 
  "Returns bracketed after point if any, nil otherwise"
  (interactive "p")
  (th-after 'bracketed arg))

;;;###autoload
(defun bounds-of-bracketed-after-pt (&optional arg) 
  "Returns bounds of bracketed after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'bracketed arg))


;;;###autoload
(defun cntrl-before-pt (&optional arg) 
  "Returns cntrl before point if any, nil otherwise"
  (interactive "p")
  (th-before 'cntrl arg))

;;;###autoload
(defun bounds-of-cntrl-before-pt (&optional arg) 
  "Returns bounds of cntrl before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'cntrl arg))

;;;###autoload
(defun cntrl-after-pt (&optional arg) 
  "Returns cntrl after point if any, nil otherwise"
  (interactive "p")
  (th-after 'cntrl arg))

;;;###autoload
(defun bounds-of-cntrl-after-pt (&optional arg) 
  "Returns bounds of cntrl after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'cntrl arg))


;;;###autoload
(defun comment-before-pt (&optional arg) 
  "Returns comment before point if any, nil otherwise"
  (interactive "p")
  (th-before 'comment arg))

;;;###autoload
(defun bounds-of-comment-before-pt (&optional arg) 
  "Returns bounds of comment before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'comment arg))

;;;###autoload
(defun comment-after-pt (&optional arg) 
  "Returns comment after point if any, nil otherwise"
  (interactive "p")
  (th-after 'comment arg))

;;;###autoload
(defun bounds-of-comment-after-pt (&optional arg) 
  "Returns bounds of comment after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'comment arg))


;;;###autoload
(defun csv-before-pt (&optional arg) 
  "Returns csv before point if any, nil otherwise"
  (interactive "p")
  (th-before 'csv arg))

;;;###autoload
(defun bounds-of-csv-before-pt (&optional arg) 
  "Returns bounds of csv before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'csv arg))

;;;###autoload
(defun csv-after-pt (&optional arg) 
  "Returns csv after point if any, nil otherwise"
  (interactive "p")
  (th-after 'csv arg))

;;;###autoload
(defun bounds-of-csv-after-pt (&optional arg) 
  "Returns bounds of csv after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'csv arg))


;;;###autoload
(defun date-before-pt (&optional arg) 
  "Returns date before point if any, nil otherwise"
  (interactive "p")
  (th-before 'date arg))

;;;###autoload
(defun bounds-of-date-before-pt (&optional arg) 
  "Returns bounds of date before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'date arg))

;;;###autoload
(defun date-after-pt (&optional arg) 
  "Returns date after point if any, nil otherwise"
  (interactive "p")
  (th-after 'date arg))

;;;###autoload
(defun bounds-of-date-after-pt (&optional arg) 
  "Returns bounds of date after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'date arg))


;;;###autoload
(defun defun-before-pt (&optional arg) 
  "Returns defun before point if any, nil otherwise"
  (interactive "p")
  (th-before 'defun arg))

;;;###autoload
(defun bounds-of-defun-before-pt (&optional arg) 
  "Returns bounds of defun before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'defun arg))

;;;###autoload
(defun defun-after-pt (&optional arg) 
  "Returns defun after point if any, nil otherwise"
  (interactive "p")
  (th-after 'defun arg))

;;;###autoload
(defun bounds-of-defun-after-pt (&optional arg) 
  "Returns bounds of defun after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'defun arg))


;;;###autoload
(defun delimited-before-pt (&optional arg) 
  "Returns delimited before point if any, nil otherwise"
  (interactive "p")
  (th-before 'delimited arg))

;;;###autoload
(defun bounds-of-delimited-before-pt (&optional arg) 
  "Returns bounds of delimited before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'delimited arg))

;;;###autoload
(defun delimited-after-pt (&optional arg) 
  "Returns delimited after point if any, nil otherwise"
  (interactive "p")
  (th-after 'delimited arg))

;;;###autoload
(defun bounds-of-delimited-after-pt (&optional arg) 
  "Returns bounds of delimited after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'delimited arg))


;;;###autoload
(defun digit-before-pt (&optional arg) 
  "Returns digit before point if any, nil otherwise"
  (interactive "p")
  (th-before 'digit arg))

;;;###autoload
(defun bounds-of-digit-before-pt (&optional arg) 
  "Returns bounds of digit before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'digit arg))

;;;###autoload
(defun digit-after-pt (&optional arg) 
  "Returns digit after point if any, nil otherwise"
  (interactive "p")
  (th-after 'digit arg))

;;;###autoload
(defun bounds-of-digit-after-pt (&optional arg) 
  "Returns bounds of digit after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'digit arg))


;;;###autoload
(defun dollared-before-pt (&optional arg) 
  "Returns dollared before point if any, nil otherwise"
  (interactive "p")
  (th-before 'dollared arg))

;;;###autoload
(defun bounds-of-dollared-before-pt (&optional arg) 
  "Returns bounds of dollared before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'dollared arg))

;;;###autoload
(defun dollared-after-pt (&optional arg) 
  "Returns dollared after point if any, nil otherwise"
  (interactive "p")
  (th-after 'dollared arg))

;;;###autoload
(defun bounds-of-dollared-after-pt (&optional arg) 
  "Returns bounds of dollared after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'dollared arg))


;;;###autoload
(defun doublequoted-before-pt (&optional arg) 
  "Returns doublequoted before point if any, nil otherwise"
  (interactive "p")
  (th-before 'doublequoted arg))

;;;###autoload
(defun bounds-of-doublequoted-before-pt (&optional arg) 
  "Returns bounds of doublequoted before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'doublequoted arg))

;;;###autoload
(defun doublequoted-after-pt (&optional arg) 
  "Returns doublequoted after point if any, nil otherwise"
  (interactive "p")
  (th-after 'doublequoted arg))

;;;###autoload
(defun bounds-of-doublequoted-after-pt (&optional arg) 
  "Returns bounds of doublequoted after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'doublequoted arg))


;;;###autoload
(defun email-before-pt (&optional arg) 
  "Returns email before point if any, nil otherwise"
  (interactive "p")
  (th-before 'email arg))

;;;###autoload
(defun bounds-of-email-before-pt (&optional arg) 
  "Returns bounds of email before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'email arg))

;;;###autoload
(defun email-after-pt (&optional arg) 
  "Returns email after point if any, nil otherwise"
  (interactive "p")
  (th-after 'email arg))

;;;###autoload
(defun bounds-of-email-after-pt (&optional arg) 
  "Returns bounds of email after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'email arg))


;;;###autoload
(defun filename-before-pt (&optional arg) 
  "Returns filename before point if any, nil otherwise"
  (interactive "p")
  (th-before 'filename arg))

;;;###autoload
(defun bounds-of-filename-before-pt (&optional arg) 
  "Returns bounds of filename before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'filename arg))

;;;###autoload
(defun filename-after-pt (&optional arg) 
  "Returns filename after point if any, nil otherwise"
  (interactive "p")
  (th-after 'filename arg))

;;;###autoload
(defun bounds-of-filename-after-pt (&optional arg) 
  "Returns bounds of filename after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'filename arg))


;;;###autoload
(defun float-before-pt (&optional arg) 
  "Returns float before point if any, nil otherwise"
  (interactive "p")
  (th-before 'float arg))

;;;###autoload
(defun bounds-of-float-before-pt (&optional arg) 
  "Returns bounds of float before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'float arg))

;;;###autoload
(defun float-after-pt (&optional arg) 
  "Returns float after point if any, nil otherwise"
  (interactive "p")
  (th-after 'float arg))

;;;###autoload
(defun bounds-of-float-after-pt (&optional arg) 
  "Returns bounds of float after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'float arg))


;;;###autoload
(defun function-before-pt (&optional arg) 
  "Returns function before point if any, nil otherwise"
  (interactive "p")
  (th-before 'function arg))

;;;###autoload
(defun bounds-of-function-before-pt (&optional arg) 
  "Returns bounds of function before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'function arg))

;;;###autoload
(defun function-after-pt (&optional arg) 
  "Returns function after point if any, nil otherwise"
  (interactive "p")
  (th-after 'function arg))

;;;###autoload
(defun bounds-of-function-after-pt (&optional arg) 
  "Returns bounds of function after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'function arg))


;;;###autoload
(defun graph-before-pt (&optional arg) 
  "Returns graph before point if any, nil otherwise"
  (interactive "p")
  (th-before 'graph arg))

;;;###autoload
(defun bounds-of-graph-before-pt (&optional arg) 
  "Returns bounds of graph before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'graph arg))

;;;###autoload
(defun graph-after-pt (&optional arg) 
  "Returns graph after point if any, nil otherwise"
  (interactive "p")
  (th-after 'graph arg))

;;;###autoload
(defun bounds-of-graph-after-pt (&optional arg) 
  "Returns bounds of graph after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'graph arg))


;;;###autoload
(defun ip-before-pt (&optional arg) 
  "Returns ip before point if any, nil otherwise"
  (interactive "p")
  (th-before 'ip arg))

;;;###autoload
(defun bounds-of-ip-before-pt (&optional arg) 
  "Returns bounds of ip before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'ip arg))

;;;###autoload
(defun ip-after-pt (&optional arg) 
  "Returns ip after point if any, nil otherwise"
  (interactive "p")
  (th-after 'ip arg))

;;;###autoload
(defun bounds-of-ip-after-pt (&optional arg) 
  "Returns bounds of ip after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'ip arg))


;;;###autoload
(defun isbn-before-pt (&optional arg) 
  "Returns isbn before point if any, nil otherwise"
  (interactive "p")
  (th-before 'isbn arg))

;;;###autoload
(defun bounds-of-isbn-before-pt (&optional arg) 
  "Returns bounds of isbn before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'isbn arg))

;;;###autoload
(defun isbn-after-pt (&optional arg) 
  "Returns isbn after point if any, nil otherwise"
  (interactive "p")
  (th-after 'isbn arg))

;;;###autoload
(defun bounds-of-isbn-after-pt (&optional arg) 
  "Returns bounds of isbn after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'isbn arg))


;;;###autoload
(defun line-before-pt (&optional arg) 
  "Returns line before point if any, nil otherwise"
  (interactive "p")
  (th-before 'line arg))

;;;###autoload
(defun bounds-of-line-before-pt (&optional arg) 
  "Returns bounds of line before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'line arg))

;;;###autoload
(defun line-after-pt (&optional arg) 
  "Returns line after point if any, nil otherwise"
  (interactive "p")
  (th-after 'line arg))

;;;###autoload
(defun bounds-of-line-after-pt (&optional arg) 
  "Returns bounds of line after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'line arg))


;;;###autoload
(defun list-before-pt (&optional arg) 
  "Returns list before point if any, nil otherwise"
  (interactive "p")
  (th-before 'list arg))

;;;###autoload
(defun bounds-of-list-before-pt (&optional arg) 
  "Returns bounds of list before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'list arg))

;;;###autoload
(defun list-after-pt (&optional arg) 
  "Returns list after point if any, nil otherwise"
  (interactive "p")
  (th-after 'list arg))

;;;###autoload
(defun bounds-of-list-after-pt (&optional arg) 
  "Returns bounds of list after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'list arg))


;;;###autoload
(defun lower-before-pt (&optional arg) 
  "Returns lower before point if any, nil otherwise"
  (interactive "p")
  (th-before 'lower arg))

;;;###autoload
(defun bounds-of-lower-before-pt (&optional arg) 
  "Returns bounds of lower before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'lower arg))

;;;###autoload
(defun lower-after-pt (&optional arg) 
  "Returns lower after point if any, nil otherwise"
  (interactive "p")
  (th-after 'lower arg))

;;;###autoload
(defun bounds-of-lower-after-pt (&optional arg) 
  "Returns bounds of lower after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'lower arg))


;;;###autoload
(defun ml-text-before-pt (&optional arg) 
  "Returns ml-text before point if any, nil otherwise"
  (interactive "p")
  (th-before 'ml-text arg))

;;;###autoload
(defun bounds-of-ml-text-before-pt (&optional arg) 
  "Returns bounds of ml-text before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'ml-text arg))

;;;###autoload
(defun ml-text-after-pt (&optional arg) 
  "Returns ml-text after point if any, nil otherwise"
  (interactive "p")
  (th-after 'ml-text arg))

;;;###autoload
(defun bounds-of-ml-text-after-pt (&optional arg) 
  "Returns bounds of ml-text after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'ml-text arg))


;;;###autoload
(defun multibyte-before-pt (&optional arg) 
  "Returns multibyte before point if any, nil otherwise"
  (interactive "p")
  (th-before 'multibyte arg))

;;;###autoload
(defun bounds-of-multibyte-before-pt (&optional arg) 
  "Returns bounds of multibyte before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'multibyte arg))

;;;###autoload
(defun multibyte-after-pt (&optional arg) 
  "Returns multibyte after point if any, nil otherwise"
  (interactive "p")
  (th-after 'multibyte arg))

;;;###autoload
(defun bounds-of-multibyte-after-pt (&optional arg) 
  "Returns bounds of multibyte after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'multibyte arg))


;;;###autoload
(defun nonascii-before-pt (&optional arg) 
  "Returns nonascii before point if any, nil otherwise"
  (interactive "p")
  (th-before 'nonascii arg))

;;;###autoload
(defun bounds-of-nonascii-before-pt (&optional arg) 
  "Returns bounds of nonascii before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'nonascii arg))

;;;###autoload
(defun nonascii-after-pt (&optional arg) 
  "Returns nonascii after point if any, nil otherwise"
  (interactive "p")
  (th-after 'nonascii arg))

;;;###autoload
(defun bounds-of-nonascii-after-pt (&optional arg) 
  "Returns bounds of nonascii after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'nonascii arg))


;;;###autoload
(defun number-before-pt (&optional arg) 
  "Returns number before point if any, nil otherwise"
  (interactive "p")
  (th-before 'number arg))

;;;###autoload
(defun bounds-of-number-before-pt (&optional arg) 
  "Returns bounds of number before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'number arg))

;;;###autoload
(defun number-after-pt (&optional arg) 
  "Returns number after point if any, nil otherwise"
  (interactive "p")
  (th-after 'number arg))

;;;###autoload
(defun bounds-of-number-after-pt (&optional arg) 
  "Returns bounds of number after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'number arg))


;;;###autoload
(defun page-before-pt (&optional arg) 
  "Returns page before point if any, nil otherwise"
  (interactive "p")
  (th-before 'page arg))

;;;###autoload
(defun bounds-of-page-before-pt (&optional arg) 
  "Returns bounds of page before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'page arg))

;;;###autoload
(defun page-after-pt (&optional arg) 
  "Returns page after point if any, nil otherwise"
  (interactive "p")
  (th-after 'page arg))

;;;###autoload
(defun bounds-of-page-after-pt (&optional arg) 
  "Returns bounds of page after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'page arg))


;;;###autoload
(defun paragraph-before-pt (&optional arg) 
  "Returns paragraph before point if any, nil otherwise"
  (interactive "p")
  (th-before 'paragraph arg))

;;;###autoload
(defun bounds-of-paragraph-before-pt (&optional arg) 
  "Returns bounds of paragraph before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'paragraph arg))

;;;###autoload
(defun paragraph-after-pt (&optional arg) 
  "Returns paragraph after point if any, nil otherwise"
  (interactive "p")
  (th-after 'paragraph arg))

;;;###autoload
(defun bounds-of-paragraph-after-pt (&optional arg) 
  "Returns bounds of paragraph after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'paragraph arg))


;;;###autoload
(defun paren-before-pt (&optional arg) 
  "Returns paren before point if any, nil otherwise"
  (interactive "p")
  (th-before 'paren arg))

;;;###autoload
(defun bounds-of-paren-before-pt (&optional arg) 
  "Returns bounds of paren before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'paren arg))

;;;###autoload
(defun paren-after-pt (&optional arg) 
  "Returns paren after point if any, nil otherwise"
  (interactive "p")
  (th-after 'paren arg))

;;;###autoload
(defun bounds-of-paren-after-pt (&optional arg) 
  "Returns bounds of paren after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'paren arg))


;;;###autoload
(defun parentized-before-pt (&optional arg) 
  "Returns parentized before point if any, nil otherwise"
  (interactive "p")
  (th-before 'parentized arg))

;;;###autoload
(defun bounds-of-parentized-before-pt (&optional arg) 
  "Returns bounds of parentized before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'parentized arg))

;;;###autoload
(defun parentized-after-pt (&optional arg) 
  "Returns parentized after point if any, nil otherwise"
  (interactive "p")
  (th-after 'parentized arg))

;;;###autoload
(defun bounds-of-parentized-after-pt (&optional arg) 
  "Returns bounds of parentized after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'parentized arg))


;;;###autoload
(defun phone-before-pt (&optional arg) 
  "Returns phone before point if any, nil otherwise"
  (interactive "p")
  (th-before 'phone arg))

;;;###autoload
(defun bounds-of-phone-before-pt (&optional arg) 
  "Returns bounds of phone before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'phone arg))

;;;###autoload
(defun phone-after-pt (&optional arg) 
  "Returns phone after point if any, nil otherwise"
  (interactive "p")
  (th-after 'phone arg))

;;;###autoload
(defun bounds-of-phone-after-pt (&optional arg) 
  "Returns bounds of phone after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'phone arg))


;;;###autoload
(defun print-before-pt (&optional arg) 
  "Returns print before point if any, nil otherwise"
  (interactive "p")
  (th-before 'print arg))

;;;###autoload
(defun bounds-of-print-before-pt (&optional arg) 
  "Returns bounds of print before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'print arg))

;;;###autoload
(defun print-after-pt (&optional arg) 
  "Returns print after point if any, nil otherwise"
  (interactive "p")
  (th-after 'print arg))

;;;###autoload
(defun bounds-of-print-after-pt (&optional arg) 
  "Returns bounds of print after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'print arg))


;;;###autoload
(defun punct-before-pt (&optional arg) 
  "Returns punct before point if any, nil otherwise"
  (interactive "p")
  (th-before 'punct arg))

;;;###autoload
(defun bounds-of-punct-before-pt (&optional arg) 
  "Returns bounds of punct before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'punct arg))

;;;###autoload
(defun punct-after-pt (&optional arg) 
  "Returns punct after point if any, nil otherwise"
  (interactive "p")
  (th-after 'punct arg))

;;;###autoload
(defun bounds-of-punct-after-pt (&optional arg) 
  "Returns bounds of punct after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'punct arg))


;;;###autoload
(defun region-before-pt (&optional arg) 
  "Returns region before point if any, nil otherwise"
  (interactive "p")
  (th-before 'region arg))

;;;###autoload
(defun bounds-of-region-before-pt (&optional arg) 
  "Returns bounds of region before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'region arg))

;;;###autoload
(defun region-after-pt (&optional arg) 
  "Returns region after point if any, nil otherwise"
  (interactive "p")
  (th-after 'region arg))

;;;###autoload
(defun bounds-of-region-after-pt (&optional arg) 
  "Returns bounds of region after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'region arg))


;;;###autoload
(defun sentence-before-pt (&optional arg) 
  "Returns sentence before point if any, nil otherwise"
  (interactive "p")
  (th-before 'sentence arg))

;;;###autoload
(defun bounds-of-sentence-before-pt (&optional arg) 
  "Returns bounds of sentence before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'sentence arg))

;;;###autoload
(defun sentence-after-pt (&optional arg) 
  "Returns sentence after point if any, nil otherwise"
  (interactive "p")
  (th-after 'sentence arg))

;;;###autoload
(defun bounds-of-sentence-after-pt (&optional arg) 
  "Returns bounds of sentence after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'sentence arg))


;;;###autoload
(defun sexp-before-pt (&optional arg) 
  "Returns sexp before point if any, nil otherwise"
  (interactive "p")
  (th-before 'sexp arg))

;;;###autoload
(defun bounds-of-sexp-before-pt (&optional arg) 
  "Returns bounds of sexp before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'sexp arg))

;;;###autoload
(defun sexp-after-pt (&optional arg) 
  "Returns sexp after point if any, nil otherwise"
  (interactive "p")
  (th-after 'sexp arg))

;;;###autoload
(defun bounds-of-sexp-after-pt (&optional arg) 
  "Returns bounds of sexp after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'sexp arg))


;;;###autoload
(defun singlequoted-before-pt (&optional arg) 
  "Returns singlequoted before point if any, nil otherwise"
  (interactive "p")
  (th-before 'singlequoted arg))

;;;###autoload
(defun bounds-of-singlequoted-before-pt (&optional arg) 
  "Returns bounds of singlequoted before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'singlequoted arg))

;;;###autoload
(defun singlequoted-after-pt (&optional arg) 
  "Returns singlequoted after point if any, nil otherwise"
  (interactive "p")
  (th-after 'singlequoted arg))

;;;###autoload
(defun bounds-of-singlequoted-after-pt (&optional arg) 
  "Returns bounds of singlequoted after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'singlequoted arg))


;;;###autoload
(defun slashed-before-pt (&optional arg) 
  "Returns slashed before point if any, nil otherwise"
  (interactive "p")
  (th-before 'slashed arg))

;;;###autoload
(defun bounds-of-slashed-before-pt (&optional arg) 
  "Returns bounds of slashed before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'slashed arg))

;;;###autoload
(defun slashed-after-pt (&optional arg) 
  "Returns slashed after point if any, nil otherwise"
  (interactive "p")
  (th-after 'slashed arg))

;;;###autoload
(defun bounds-of-slashed-after-pt (&optional arg) 
  "Returns bounds of slashed after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'slashed arg))


;;;###autoload
(defun space-before-pt (&optional arg) 
  "Returns space before point if any, nil otherwise"
  (interactive "p")
  (th-before 'space arg))

;;;###autoload
(defun bounds-of-space-before-pt (&optional arg) 
  "Returns bounds of space before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'space arg))

;;;###autoload
(defun space-after-pt (&optional arg) 
  "Returns space after point if any, nil otherwise"
  (interactive "p")
  (th-after 'space arg))

;;;###autoload
(defun bounds-of-space-after-pt (&optional arg) 
  "Returns bounds of space after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'space arg))


;;;###autoload
(defun string-before-pt (&optional arg) 
  "Returns string before point if any, nil otherwise"
  (interactive "p")
  (th-before 'string arg))

;;;###autoload
(defun bounds-of-string-before-pt (&optional arg) 
  "Returns bounds of string before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'string arg))

;;;###autoload
(defun string-after-pt (&optional arg) 
  "Returns string after point if any, nil otherwise"
  (interactive "p")
  (th-after 'string arg))

;;;###autoload
(defun bounds-of-string-after-pt (&optional arg) 
  "Returns bounds of string after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'string arg))


;;;###autoload
(defun sh-struct-before-pt (&optional arg) 
  "Returns sh-struct before point if any, nil otherwise"
  (interactive "p")
  (th-before 'sh-struct arg))

;;;###autoload
(defun bounds-of-sh-struct-before-pt (&optional arg) 
  "Returns bounds of sh-struct before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'sh-struct arg))

;;;###autoload
(defun sh-struct-after-pt (&optional arg) 
  "Returns sh-struct after point if any, nil otherwise"
  (interactive "p")
  (th-after 'sh-struct arg))

;;;###autoload
(defun bounds-of-sh-struct-after-pt (&optional arg) 
  "Returns bounds of sh-struct after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'sh-struct arg))


;;;###autoload
(defun symbol-before-pt (&optional arg) 
  "Returns symbol before point if any, nil otherwise"
  (interactive "p")
  (th-before 'symbol arg))

;;;###autoload
(defun bounds-of-symbol-before-pt (&optional arg) 
  "Returns bounds of symbol before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'symbol arg))

;;;###autoload
(defun symbol-after-pt (&optional arg) 
  "Returns symbol after point if any, nil otherwise"
  (interactive "p")
  (th-after 'symbol arg))

;;;###autoload
(defun bounds-of-symbol-after-pt (&optional arg) 
  "Returns bounds of symbol after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'symbol arg))


;;;###autoload
(defun td-before-pt (&optional arg) 
  "Returns td before point if any, nil otherwise"
  (interactive "p")
  (th-before 'td arg))

;;;###autoload
(defun bounds-of-td-before-pt (&optional arg) 
  "Returns bounds of td before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'td arg))

;;;###autoload
(defun td-after-pt (&optional arg) 
  "Returns td after point if any, nil otherwise"
  (interactive "p")
  (th-after 'td arg))

;;;###autoload
(defun bounds-of-td-after-pt (&optional arg) 
  "Returns bounds of td after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'td arg))


;;;###autoload
(defun unibyte-before-pt (&optional arg) 
  "Returns unibyte before point if any, nil otherwise"
  (interactive "p")
  (th-before 'unibyte arg))

;;;###autoload
(defun bounds-of-unibyte-before-pt (&optional arg) 
  "Returns bounds of unibyte before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'unibyte arg))

;;;###autoload
(defun unibyte-after-pt (&optional arg) 
  "Returns unibyte after point if any, nil otherwise"
  (interactive "p")
  (th-after 'unibyte arg))

;;;###autoload
(defun bounds-of-unibyte-after-pt (&optional arg) 
  "Returns bounds of unibyte after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'unibyte arg))


;;;###autoload
(defun upper-before-pt (&optional arg) 
  "Returns upper before point if any, nil otherwise"
  (interactive "p")
  (th-before 'upper arg))

;;;###autoload
(defun bounds-of-upper-before-pt (&optional arg) 
  "Returns bounds of upper before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'upper arg))

;;;###autoload
(defun upper-after-pt (&optional arg) 
  "Returns upper after point if any, nil otherwise"
  (interactive "p")
  (th-after 'upper arg))

;;;###autoload
(defun bounds-of-upper-after-pt (&optional arg) 
  "Returns bounds of upper after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'upper arg))


;;;###autoload
(defun url-before-pt (&optional arg) 
  "Returns url before point if any, nil otherwise"
  (interactive "p")
  (th-before 'url arg))

;;;###autoload
(defun bounds-of-url-before-pt (&optional arg) 
  "Returns bounds of url before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'url arg))

;;;###autoload
(defun url-after-pt (&optional arg) 
  "Returns url after point if any, nil otherwise"
  (interactive "p")
  (th-after 'url arg))

;;;###autoload
(defun bounds-of-url-after-pt (&optional arg) 
  "Returns bounds of url after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'url arg))


;;;###autoload
(defun whitespace-before-pt (&optional arg) 
  "Returns whitespace before point if any, nil otherwise"
  (interactive "p")
  (th-before 'whitespace arg))

;;;###autoload
(defun bounds-of-whitespace-before-pt (&optional arg) 
  "Returns bounds of whitespace before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'whitespace arg))

;;;###autoload
(defun whitespace-after-pt (&optional arg) 
  "Returns whitespace after point if any, nil otherwise"
  (interactive "p")
  (th-after 'whitespace arg))

;;;###autoload
(defun bounds-of-whitespace-after-pt (&optional arg) 
  "Returns bounds of whitespace after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'whitespace arg))


;;;###autoload
(defun word-before-pt (&optional arg) 
  "Returns word before point if any, nil otherwise"
  (interactive "p")
  (th-before 'word arg))

;;;###autoload
(defun bounds-of-word-before-pt (&optional arg) 
  "Returns bounds of word before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'word arg))

;;;###autoload
(defun word-after-pt (&optional arg) 
  "Returns word after point if any, nil otherwise"
  (interactive "p")
  (th-after 'word arg))

;;;###autoload
(defun bounds-of-word-after-pt (&optional arg) 
  "Returns bounds of word after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'word arg))


;;;###autoload
(defun xdigit-before-pt (&optional arg) 
  "Returns xdigit before point if any, nil otherwise"
  (interactive "p")
  (th-before 'xdigit arg))

;;;###autoload
(defun bounds-of-xdigit-before-pt (&optional arg) 
  "Returns bounds of xdigit before point if any, nil otherwise"
  (interactive "p")
  (th-bounds-before 'xdigit arg))

;;;###autoload
(defun xdigit-after-pt (&optional arg) 
  "Returns xdigit after point if any, nil otherwise"
  (interactive "p")
  (th-after 'xdigit arg))

;;;###autoload
(defun bounds-of-xdigit-after-pt (&optional arg) 
  "Returns bounds of xdigit after point if any, nil otherwise"
  (interactive "p")
  (th-bounds-after 'xdigit arg))


(provide 'thingatpt-before-after)
;;; thingatpt-before-after.el ends here
