;;; thingatpt-utils-test.el   --- more th-at-point edit functions

;; Version: 1.13

;; Copyright (C) 2006, 2007, 2008, 2009 Andreas Roehler, unless
;; indicated otherwise

;; Author: Andreas Roehler <andreas.roehler@easy-emacs.de>, unless
;; indicated otherwise

;; Keywords: convenience

;; This file is free software; you can redistribute it

;; and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2, or (at your option) any later version.

;; This file is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with GNU Emacs; see the file COPYING.  If not, write to
;; the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301, USA.

;;; Commentary:

;; Information is given with thingatpt-utils-base.el

(require 'thingatpt-utils-base)




(defun th-test (&optional arg) 
  "Checks available THING-atpt forms at point
  Prints forms with values in bufffer `th-test', 
  with ARG also forms, which returned `nil' "
  (interactive "p")
  (message "%s" "Testing, please wait!") 
  (let 
      ((pos (point))
       (arg (or arg 1)) 
       (th-fnlist '(
                    alnum-atpt
                    alnum-bounds-atpt
                    alnum-end-position-atpt
                    alnum-copy-atpt
                    alpha-atpt
                    alpha-bounds-atpt
                    alpha-end-position-atpt
                    alpha-copy-atpt
                    angled-no-nest-atpt
                    angled-no-nest-bounds-atpt
                    angled-no-nest-end-position-atpt
                    angled-no-nest-copy-atpt
                    angled-greater-atpt
                    angled-greater-bounds-atpt
                    angled-greater-end-position-atpt
                    angled-greater-copy-atpt
                    angled-lower-atpt
                    angled-lower-bounds-atpt
                    angled-lower-end-position-atpt
                    angled-lower-copy-atpt
                    ascii-atpt
                    ascii-bounds-atpt
                    ascii-end-position-atpt
                    ascii-copy-atpt
                    backslashed-atpt
                    backslashed-bounds-atpt
                    backslashed-end-position-atpt
                    backslashed-copy-atpt
                    blank-atpt
                    blank-bounds-atpt
                    blank-end-position-atpt
                    blank-copy-atpt
                    braced-atpt
                    braced-bounds-atpt
                    braced-end-position-atpt
                    braced-copy-atpt
                    bracketed-atpt
                    bracketed-bounds-atpt
                    bracketed-end-position-atpt
                    bracketed-copy-atpt
                    cntrl-atpt
                    cntrl-bounds-atpt
                    cntrl-end-position-atpt
                    cntrl-copy-atpt
                    comment-atpt
                    comment-bounds-atpt
                    comment-end-position-atpt
                    comment-copy-atpt
                    csv-atpt
                    csv-bounds-atpt
                    csv-end-position-atpt
                    csv-copy-atpt
                    date-atpt
                    date-bounds-atpt
                    date-end-position-atpt
                    date-copy-atpt
                    defun-atpt
                    defun-bounds-atpt
                    defun-end-position-atpt
                    defun-copy-atpt
                    delimited-atpt
                    delimited-bounds-atpt
                    delimited-end-position-atpt
                    delimited-copy-atpt
                    digit-atpt
                    digit-bounds-atpt
                    digit-end-position-atpt
                    digit-copy-atpt
                    dollared-atpt
                    dollared-bounds-atpt
                    dollared-end-position-atpt
                    dollared-copy-atpt
                    doublequoted-atpt
                    doublequoted-bounds-atpt
                    doublequoted-end-position-atpt
                    doublequoted-copy-atpt
                    email-atpt
                    email-bounds-atpt
                    email-end-position-atpt
                    email-copy-atpt
                    filename-atpt
                    filename-bounds-atpt
                    filename-end-position-atpt
                    filename-copy-atpt
                    float-atpt
                    float-bounds-atpt
                    float-end-position-atpt
                    float-copy-atpt
                    function-atpt
                    function-bounds-atpt
                    function-end-position-atpt
                    function-copy-atpt
                    graph-atpt
                    graph-bounds-atpt
                    graph-end-position-atpt
                    graph-copy-atpt
                    ip-atpt
                    ip-bounds-atpt
                    ip-end-position-atpt
                    ip-copy-atpt
                    isbn-atpt
                    isbn-bounds-atpt
                    isbn-end-position-atpt
                    isbn-copy-atpt
                    line-atpt
                    line-bounds-atpt
                    line-end-position-atpt
                    line-copy-atpt
                    list-atpt
                    list-bounds-atpt
                    list-end-position-atpt
                    list-copy-atpt
                    lower-atpt
                    lower-bounds-atpt
                    lower-end-position-atpt
                    lower-copy-atpt
                    ml-text-atpt
                    ml-text-bounds-atpt
                    ml-text-end-position-atpt
                    ml-text-copy-atpt
                    multibyte-atpt
                    multibyte-bounds-atpt
                    multibyte-end-position-atpt
                    multibyte-copy-atpt
                    nonascii-atpt
                    nonascii-bounds-atpt
                    nonascii-end-position-atpt
                    nonascii-copy-atpt
                    number-atpt
                    number-bounds-atpt
                    number-end-position-atpt
                    number-copy-atpt
                    page-atpt
                    page-bounds-atpt
                    page-end-position-atpt
                    page-copy-atpt
                    paragraph-atpt
                    paragraph-bounds-atpt
                    paragraph-end-position-atpt
                    paragraph-copy-atpt
                    paren-atpt
                    paren-bounds-atpt
                    paren-end-position-atpt
                    paren-copy-atpt
                    parentized-atpt
                    parentized-bounds-atpt
                    parentized-end-position-atpt
                    parentized-copy-atpt
                    phone-atpt
                    phone-bounds-atpt
                    phone-end-position-atpt
                    phone-copy-atpt
                    print-atpt
                    print-bounds-atpt
                    print-end-position-atpt
                    print-copy-atpt
                    punct-atpt
                    punct-bounds-atpt
                    punct-end-position-atpt
                    punct-copy-atpt
                    region-atpt
                    region-bounds-atpt
                    region-end-position-atpt
                    region-copy-atpt
                    sentence-atpt
                    sentence-bounds-atpt
                    sentence-end-position-atpt
                    sentence-copy-atpt
                    sexp-atpt
                    sexp-bounds-atpt
                    sexp-end-position-atpt
                    sexp-copy-atpt
                    singlequoted-atpt
                    singlequoted-bounds-atpt
                    singlequoted-end-position-atpt
                    singlequoted-copy-atpt
                    slashed-atpt
                    slashed-bounds-atpt
                    slashed-end-position-atpt
                    slashed-copy-atpt
                    space-atpt
                    space-bounds-atpt
                    space-end-position-atpt
                    space-copy-atpt
                    string-atpt
                    string-bounds-atpt
                    string-end-position-atpt
                    string-copy-atpt
                    sh-struct-atpt
                    sh-struct-bounds-atpt
                    sh-struct-end-position-atpt
                    sh-struct-copy-atpt
                    symbol-atpt
                    symbol-bounds-atpt
                    symbol-end-position-atpt
                    symbol-copy-atpt
                    td-atpt
                    td-bounds-atpt
                    td-end-position-atpt
                    td-copy-atpt
                    unibyte-atpt
                    unibyte-bounds-atpt
                    unibyte-end-position-atpt
                    unibyte-copy-atpt
                    upper-atpt
                    upper-bounds-atpt
                    upper-end-position-atpt
                    upper-copy-atpt
                    url-atpt
                    url-bounds-atpt
                    url-end-position-atpt
                    url-copy-atpt
                    whitespace-atpt
                    whitespace-bounds-atpt
                    whitespace-end-position-atpt
                    whitespace-copy-atpt
                    word-atpt
                    word-bounds-atpt
                    word-end-position-atpt
                    word-copy-atpt
                    xdigit-atpt
                    xdigit-bounds-atpt
                    xdigit-end-position-atpt
                    xdigit-copy-atpt)))
    (save-excursion 
      (set-buffer (get-buffer-create "th-test"))
      (erase-buffer)
      (insert (format "Point: %s" pos))
      (newline)) 
    (dolist (elt th-fnlist)
      (let* ((first (split-string (format "%s" elt) "-"))
	     (thing (car first)))
	(unless (and (featurep 'xemacs) (member thing th-classes))
          (let* ((item (funcall elt))
                 (output-p (if arg
                               t
                             (cond ((eq nil item)
                                    nil)
                                   ((and (listp item)
                                         (eq nil (car item)))
                                    nil)
                                   ((and (stringp item)
                                         (string= "" item))
                                    nil)
                                   (t t)))))
            (when output-p
              (save-excursion 
                (switch-to-buffer "th-test")
                (if (listp item)
                    (setq item (concat (format "%s" (car item))" "(format "%s" (cdr item)))))
                (insert (concat (format "%s: " elt) (format "%s \n" item)))))))))
    (message "%s" "Test finished, please check the results!")))

(defun th-mv-test (&optional arg) 
  "Checks available move-THING-atpt forms at point.
  Shows moves while indicating executed form in message-buffer"
  (interactive "p")
  (let 
      ((arg (or arg 1)) 
       (th-mv-fnlist '(
                       alnum-forward-atpt
                       alnum-backward-atpt
                       alpha-forward-atpt
                       alpha-backward-atpt
                       angled-no-nest-forward-atpt
                       angled-no-nest-backward-atpt
                       angled-greater-forward-atpt
                       angled-greater-backward-atpt
                       angled-lower-forward-atpt
                       angled-lower-backward-atpt
                       ascii-forward-atpt
                       ascii-backward-atpt
                       backslashed-forward-atpt
                       backslashed-backward-atpt
                       blank-forward-atpt
                       blank-backward-atpt
                       braced-forward-atpt
                       braced-backward-atpt
                       bracketed-forward-atpt
                       bracketed-backward-atpt
                       cntrl-forward-atpt
                       cntrl-backward-atpt
                       comment-forward-atpt
                       comment-backward-atpt
                       csv-forward-atpt
                       csv-backward-atpt
                       date-forward-atpt
                       date-backward-atpt
                       defun-forward-atpt
                       defun-backward-atpt
                       delimited-forward-atpt
                       delimited-backward-atpt
                       digit-forward-atpt
                       digit-backward-atpt
                       dollared-forward-atpt
                       dollared-backward-atpt
                       doublequoted-forward-atpt
                       doublequoted-backward-atpt
                       email-forward-atpt
                       email-backward-atpt
                       filename-forward-atpt
                       filename-backward-atpt
                       float-forward-atpt
                       float-backward-atpt
                       function-forward-atpt
                       function-backward-atpt
                       graph-forward-atpt
                       graph-backward-atpt
                       ip-forward-atpt
                       ip-backward-atpt
                       isbn-forward-atpt
                       isbn-backward-atpt
                       line-forward-atpt
                       line-backward-atpt
                       list-forward-atpt
                       list-backward-atpt
                       lower-forward-atpt
                       lower-backward-atpt
                       ml-text-forward-atpt
                       ml-text-backward-atpt
                       multibyte-forward-atpt
                       multibyte-backward-atpt
                       nonascii-forward-atpt
                       nonascii-backward-atpt
                       number-forward-atpt
                       number-backward-atpt
                       page-forward-atpt
                       page-backward-atpt
                       paragraph-forward-atpt
                       paragraph-backward-atpt
                       paren-forward-atpt
                       paren-backward-atpt
                       parentized-forward-atpt
                       parentized-backward-atpt
                       phone-forward-atpt
                       phone-backward-atpt
                       print-forward-atpt
                       print-backward-atpt
                       punct-forward-atpt
                       punct-backward-atpt
                       region-forward-atpt
                       region-backward-atpt
                       sentence-forward-atpt
                       sentence-backward-atpt
                       sexp-forward-atpt
                       sexp-backward-atpt
                       singlequoted-forward-atpt
                       singlequoted-backward-atpt
                       slashed-forward-atpt
                       slashed-backward-atpt
                       space-forward-atpt
                       space-backward-atpt
                       string-forward-atpt
                       string-backward-atpt
                       sh-struct-forward-atpt
                       sh-struct-backward-atpt
                       symbol-forward-atpt
                       symbol-backward-atpt
                       td-forward-atpt
                       td-backward-atpt
                       unibyte-forward-atpt
                       unibyte-backward-atpt
                       upper-forward-atpt
                       upper-backward-atpt
                       url-forward-atpt
                       url-backward-atpt
                       whitespace-forward-atpt
                       whitespace-backward-atpt
                       word-forward-atpt
                       word-backward-atpt
                       xdigit-forward-atpt
                       xdigit-backward-atpt)))
    (save-excursion 
      (dolist (elt th-mv-fnlist)
        (let* ((first (split-string (format "%s" elt) "-"))
               (thing (car first)))
          (unless (and (featurep 'xemacs) (member thing th-classes))
            (when
                (functionp (intern-soft elt))
              (message "   %s" elt)
              (save-excursion
                (funcall elt)
                (sit-for th-mv-test-delay)))))))
    (message "   %s" "Seems as th-mv-test completed successfully!")))

;; (setq delim-thingsat-fn 'symbol-at)

(defcustom th-delimtest-delay  1 
  "Seconds to wait until next delimtest functioncall" 
  
  :type 'number
  :group 'convenience)

(defcustom th-mv-test-delay 1 
  "" 
  :type 'number
  :group 'convenience)

(defun th-delimtest (&optional arg) 
  " "
  (interactive "*p")
  (let ((arg (or arg 1)) 
	(pos (point))
	(fns-test '(
                    alnum-greater-angle-atpt
                    alnum-lower-angle-atpt
                    backslash-alnum-atpt
                    brace-alnum-atpt
                    bracket-alnum-atpt
                    dollar-alnum-atpt
                    doublequote-alnum-atpt
                    parentize-alnum-atpt
                    separate-alnum-atpt
                    singlequote-alnum-atpt
                    slash-alnum-atpt
                    alpha-greater-angle-atpt
                    alpha-lower-angle-atpt
                    backslash-alpha-atpt
                    brace-alpha-atpt
                    bracket-alpha-atpt
                    dollar-alpha-atpt
                    doublequote-alpha-atpt
                    parentize-alpha-atpt
                    separate-alpha-atpt
                    singlequote-alpha-atpt
                    slash-alpha-atpt
                    angled-no-nest-greater-angle-atpt
                    angled-no-nest-lower-angle-atpt
                    backslash-angled-no-nest-atpt
                    brace-angled-no-nest-atpt
                    bracket-angled-no-nest-atpt
                    dollar-angled-no-nest-atpt
                    doublequote-angled-no-nest-atpt
                    parentize-angled-no-nest-atpt
                    separate-angled-no-nest-atpt
                    singlequote-angled-no-nest-atpt
                    slash-angled-no-nest-atpt
                    angled-greater-greater-angle-atpt
                    angled-greater-lower-angle-atpt
                    backslash-angled-greater-atpt
                    brace-angled-greater-atpt
                    bracket-angled-greater-atpt
                    dollar-angled-greater-atpt
                    doublequote-angled-greater-atpt
                    parentize-angled-greater-atpt
                    separate-angled-greater-atpt
                    singlequote-angled-greater-atpt
                    slash-angled-greater-atpt
                    angled-lower-greater-angle-atpt
                    angled-lower-lower-angle-atpt
                    backslash-angled-lower-atpt
                    brace-angled-lower-atpt
                    bracket-angled-lower-atpt
                    dollar-angled-lower-atpt
                    doublequote-angled-lower-atpt
                    parentize-angled-lower-atpt
                    separate-angled-lower-atpt
                    singlequote-angled-lower-atpt
                    slash-angled-lower-atpt
                    ascii-greater-angle-atpt
                    ascii-lower-angle-atpt
                    backslash-ascii-atpt
                    brace-ascii-atpt
                    bracket-ascii-atpt
                    dollar-ascii-atpt
                    doublequote-ascii-atpt
                    parentize-ascii-atpt
                    separate-ascii-atpt
                    singlequote-ascii-atpt
                    slash-ascii-atpt
                    backslashed-greater-angle-atpt
                    backslashed-lower-angle-atpt
                    backslash-backslashed-atpt
                    brace-backslashed-atpt
                    bracket-backslashed-atpt
                    dollar-backslashed-atpt
                    doublequote-backslashed-atpt
                    parentize-backslashed-atpt
                    separate-backslashed-atpt
                    singlequote-backslashed-atpt
                    slash-backslashed-atpt
                    blank-greater-angle-atpt
                    blank-lower-angle-atpt
                    backslash-blank-atpt
                    brace-blank-atpt
                    bracket-blank-atpt
                    dollar-blank-atpt
                    doublequote-blank-atpt
                    parentize-blank-atpt
                    separate-blank-atpt
                    singlequote-blank-atpt
                    slash-blank-atpt
                    braced-greater-angle-atpt
                    braced-lower-angle-atpt
                    backslash-braced-atpt
                    brace-braced-atpt
                    bracket-braced-atpt
                    dollar-braced-atpt
                    doublequote-braced-atpt
                    parentize-braced-atpt
                    separate-braced-atpt
                    singlequote-braced-atpt
                    slash-braced-atpt
                    bracketed-greater-angle-atpt
                    bracketed-lower-angle-atpt
                    backslash-bracketed-atpt
                    brace-bracketed-atpt
                    bracket-bracketed-atpt
                    dollar-bracketed-atpt
                    doublequote-bracketed-atpt
                    parentize-bracketed-atpt
                    separate-bracketed-atpt
                    singlequote-bracketed-atpt
                    slash-bracketed-atpt
                    cntrl-greater-angle-atpt
                    cntrl-lower-angle-atpt
                    backslash-cntrl-atpt
                    brace-cntrl-atpt
                    bracket-cntrl-atpt
                    dollar-cntrl-atpt
                    doublequote-cntrl-atpt
                    parentize-cntrl-atpt
                    separate-cntrl-atpt
                    singlequote-cntrl-atpt
                    slash-cntrl-atpt
                    comment-greater-angle-atpt
                    comment-lower-angle-atpt
                    backslash-comment-atpt
                    brace-comment-atpt
                    bracket-comment-atpt
                    dollar-comment-atpt
                    doublequote-comment-atpt
                    parentize-comment-atpt
                    separate-comment-atpt
                    singlequote-comment-atpt
                    slash-comment-atpt
                    csv-greater-angle-atpt
                    csv-lower-angle-atpt
                    backslash-csv-atpt
                    brace-csv-atpt
                    bracket-csv-atpt
                    dollar-csv-atpt
                    doublequote-csv-atpt
                    parentize-csv-atpt
                    separate-csv-atpt
                    singlequote-csv-atpt
                    slash-csv-atpt
                    date-greater-angle-atpt
                    date-lower-angle-atpt
                    backslash-date-atpt
                    brace-date-atpt
                    bracket-date-atpt
                    dollar-date-atpt
                    doublequote-date-atpt
                    parentize-date-atpt
                    separate-date-atpt
                    singlequote-date-atpt
                    slash-date-atpt
                    defun-greater-angle-atpt
                    defun-lower-angle-atpt
                    backslash-defun-atpt
                    brace-defun-atpt
                    bracket-defun-atpt
                    dollar-defun-atpt
                    doublequote-defun-atpt
                    parentize-defun-atpt
                    separate-defun-atpt
                    singlequote-defun-atpt
                    slash-defun-atpt
                    delimited-greater-angle-atpt
                    delimited-lower-angle-atpt
                    backslash-delimited-atpt
                    brace-delimited-atpt
                    bracket-delimited-atpt
                    dollar-delimited-atpt
                    doublequote-delimited-atpt
                    parentize-delimited-atpt
                    separate-delimited-atpt
                    singlequote-delimited-atpt
                    slash-delimited-atpt
                    digit-greater-angle-atpt
                    digit-lower-angle-atpt
                    backslash-digit-atpt
                    brace-digit-atpt
                    bracket-digit-atpt
                    dollar-digit-atpt
                    doublequote-digit-atpt
                    parentize-digit-atpt
                    separate-digit-atpt
                    singlequote-digit-atpt
                    slash-digit-atpt
                    dollared-greater-angle-atpt
                    dollared-lower-angle-atpt
                    backslash-dollared-atpt
                    brace-dollared-atpt
                    bracket-dollared-atpt
                    dollar-dollared-atpt
                    doublequote-dollared-atpt
                    parentize-dollared-atpt
                    separate-dollared-atpt
                    singlequote-dollared-atpt
                    slash-dollared-atpt
                    doublequoted-greater-angle-atpt
                    doublequoted-lower-angle-atpt
                    backslash-doublequoted-atpt
                    brace-doublequoted-atpt
                    bracket-doublequoted-atpt
                    dollar-doublequoted-atpt
                    doublequote-doublequoted-atpt
                    parentize-doublequoted-atpt
                    separate-doublequoted-atpt
                    singlequote-doublequoted-atpt
                    slash-doublequoted-atpt
                    email-greater-angle-atpt
                    email-lower-angle-atpt
                    backslash-email-atpt
                    brace-email-atpt
                    bracket-email-atpt
                    dollar-email-atpt
                    doublequote-email-atpt
                    parentize-email-atpt
                    separate-email-atpt
                    singlequote-email-atpt
                    slash-email-atpt
                    filename-greater-angle-atpt
                    filename-lower-angle-atpt
                    backslash-filename-atpt
                    brace-filename-atpt
                    bracket-filename-atpt
                    dollar-filename-atpt
                    doublequote-filename-atpt
                    parentize-filename-atpt
                    separate-filename-atpt
                    singlequote-filename-atpt
                    slash-filename-atpt
                    float-greater-angle-atpt
                    float-lower-angle-atpt
                    backslash-float-atpt
                    brace-float-atpt
                    bracket-float-atpt
                    dollar-float-atpt
                    doublequote-float-atpt
                    parentize-float-atpt
                    separate-float-atpt
                    singlequote-float-atpt
                    slash-float-atpt
                    function-greater-angle-atpt
                    function-lower-angle-atpt
                    backslash-function-atpt
                    brace-function-atpt
                    bracket-function-atpt
                    dollar-function-atpt
                    doublequote-function-atpt
                    parentize-function-atpt
                    separate-function-atpt
                    singlequote-function-atpt
                    slash-function-atpt
                    graph-greater-angle-atpt
                    graph-lower-angle-atpt
                    backslash-graph-atpt
                    brace-graph-atpt
                    bracket-graph-atpt
                    dollar-graph-atpt
                    doublequote-graph-atpt
                    parentize-graph-atpt
                    separate-graph-atpt
                    singlequote-graph-atpt
                    slash-graph-atpt
                    ip-greater-angle-atpt
                    ip-lower-angle-atpt
                    backslash-ip-atpt
                    brace-ip-atpt
                    bracket-ip-atpt
                    dollar-ip-atpt
                    doublequote-ip-atpt
                    parentize-ip-atpt
                    separate-ip-atpt
                    singlequote-ip-atpt
                    slash-ip-atpt
                    isbn-greater-angle-atpt
                    isbn-lower-angle-atpt
                    backslash-isbn-atpt
                    brace-isbn-atpt
                    bracket-isbn-atpt
                    dollar-isbn-atpt
                    doublequote-isbn-atpt
                    parentize-isbn-atpt
                    separate-isbn-atpt
                    singlequote-isbn-atpt
                    slash-isbn-atpt
                    line-greater-angle-atpt
                    line-lower-angle-atpt
                    backslash-line-atpt
                    brace-line-atpt
                    bracket-line-atpt
                    dollar-line-atpt
                    doublequote-line-atpt
                    parentize-line-atpt
                    separate-line-atpt
                    singlequote-line-atpt
                    slash-line-atpt
                    list-greater-angle-atpt
                    list-lower-angle-atpt
                    backslash-list-atpt
                    brace-list-atpt
                    bracket-list-atpt
                    dollar-list-atpt
                    doublequote-list-atpt
                    parentize-list-atpt
                    separate-list-atpt
                    singlequote-list-atpt
                    slash-list-atpt
                    lower-greater-angle-atpt
                    lower-lower-angle-atpt
                    backslash-lower-atpt
                    brace-lower-atpt
                    bracket-lower-atpt
                    dollar-lower-atpt
                    doublequote-lower-atpt
                    parentize-lower-atpt
                    separate-lower-atpt
                    singlequote-lower-atpt
                    slash-lower-atpt
                    ml-text-greater-angle-atpt
                    ml-text-lower-angle-atpt
                    backslash-ml-text-atpt
                    brace-ml-text-atpt
                    bracket-ml-text-atpt
                    dollar-ml-text-atpt
                    doublequote-ml-text-atpt
                    parentize-ml-text-atpt
                    separate-ml-text-atpt
                    singlequote-ml-text-atpt
                    slash-ml-text-atpt
                    multibyte-greater-angle-atpt
                    multibyte-lower-angle-atpt
                    backslash-multibyte-atpt
                    brace-multibyte-atpt
                    bracket-multibyte-atpt
                    dollar-multibyte-atpt
                    doublequote-multibyte-atpt
                    parentize-multibyte-atpt
                    separate-multibyte-atpt
                    singlequote-multibyte-atpt
                    slash-multibyte-atpt
                    nonascii-greater-angle-atpt
                    nonascii-lower-angle-atpt
                    backslash-nonascii-atpt
                    brace-nonascii-atpt
                    bracket-nonascii-atpt
                    dollar-nonascii-atpt
                    doublequote-nonascii-atpt
                    parentize-nonascii-atpt
                    separate-nonascii-atpt
                    singlequote-nonascii-atpt
                    slash-nonascii-atpt
                    number-greater-angle-atpt
                    number-lower-angle-atpt
                    backslash-number-atpt
                    brace-number-atpt
                    bracket-number-atpt
                    dollar-number-atpt
                    doublequote-number-atpt
                    parentize-number-atpt
                    separate-number-atpt
                    singlequote-number-atpt
                    slash-number-atpt
                    page-greater-angle-atpt
                    page-lower-angle-atpt
                    backslash-page-atpt
                    brace-page-atpt
                    bracket-page-atpt
                    dollar-page-atpt
                    doublequote-page-atpt
                    parentize-page-atpt
                    separate-page-atpt
                    singlequote-page-atpt
                    slash-page-atpt
                    paragraph-greater-angle-atpt
                    paragraph-lower-angle-atpt
                    backslash-paragraph-atpt
                    brace-paragraph-atpt
                    bracket-paragraph-atpt
                    dollar-paragraph-atpt
                    doublequote-paragraph-atpt
                    parentize-paragraph-atpt
                    separate-paragraph-atpt
                    singlequote-paragraph-atpt
                    slash-paragraph-atpt
                    paren-greater-angle-atpt
                    paren-lower-angle-atpt
                    backslash-paren-atpt
                    brace-paren-atpt
                    bracket-paren-atpt
                    dollar-paren-atpt
                    doublequote-paren-atpt
                    parentize-paren-atpt
                    separate-paren-atpt
                    singlequote-paren-atpt
                    slash-paren-atpt
                    parentized-greater-angle-atpt
                    parentized-lower-angle-atpt
                    backslash-parentized-atpt
                    brace-parentized-atpt
                    bracket-parentized-atpt
                    dollar-parentized-atpt
                    doublequote-parentized-atpt
                    parentize-parentized-atpt
                    separate-parentized-atpt
                    singlequote-parentized-atpt
                    slash-parentized-atpt
                    phone-greater-angle-atpt
                    phone-lower-angle-atpt
                    backslash-phone-atpt
                    brace-phone-atpt
                    bracket-phone-atpt
                    dollar-phone-atpt
                    doublequote-phone-atpt
                    parentize-phone-atpt
                    separate-phone-atpt
                    singlequote-phone-atpt
                    slash-phone-atpt
                    print-greater-angle-atpt
                    print-lower-angle-atpt
                    backslash-print-atpt
                    brace-print-atpt
                    bracket-print-atpt
                    dollar-print-atpt
                    doublequote-print-atpt
                    parentize-print-atpt
                    separate-print-atpt
                    singlequote-print-atpt
                    slash-print-atpt
                    punct-greater-angle-atpt
                    punct-lower-angle-atpt
                    backslash-punct-atpt
                    brace-punct-atpt
                    bracket-punct-atpt
                    dollar-punct-atpt
                    doublequote-punct-atpt
                    parentize-punct-atpt
                    separate-punct-atpt
                    singlequote-punct-atpt
                    slash-punct-atpt
                    region-greater-angle-atpt
                    region-lower-angle-atpt
                    backslash-region-atpt
                    brace-region-atpt
                    bracket-region-atpt
                    dollar-region-atpt
                    doublequote-region-atpt
                    parentize-region-atpt
                    separate-region-atpt
                    singlequote-region-atpt
                    slash-region-atpt
                    sentence-greater-angle-atpt
                    sentence-lower-angle-atpt
                    backslash-sentence-atpt
                    brace-sentence-atpt
                    bracket-sentence-atpt
                    dollar-sentence-atpt
                    doublequote-sentence-atpt
                    parentize-sentence-atpt
                    separate-sentence-atpt
                    singlequote-sentence-atpt
                    slash-sentence-atpt
                    sexp-greater-angle-atpt
                    sexp-lower-angle-atpt
                    backslash-sexp-atpt
                    brace-sexp-atpt
                    bracket-sexp-atpt
                    dollar-sexp-atpt
                    doublequote-sexp-atpt
                    parentize-sexp-atpt
                    separate-sexp-atpt
                    singlequote-sexp-atpt
                    slash-sexp-atpt
                    singlequoted-greater-angle-atpt
                    singlequoted-lower-angle-atpt
                    backslash-singlequoted-atpt
                    brace-singlequoted-atpt
                    bracket-singlequoted-atpt
                    dollar-singlequoted-atpt
                    doublequote-singlequoted-atpt
                    parentize-singlequoted-atpt
                    separate-singlequoted-atpt
                    singlequote-singlequoted-atpt
                    slash-singlequoted-atpt
                    slashed-greater-angle-atpt
                    slashed-lower-angle-atpt
                    backslash-slashed-atpt
                    brace-slashed-atpt
                    bracket-slashed-atpt
                    dollar-slashed-atpt
                    doublequote-slashed-atpt
                    parentize-slashed-atpt
                    separate-slashed-atpt
                    singlequote-slashed-atpt
                    slash-slashed-atpt
                    space-greater-angle-atpt
                    space-lower-angle-atpt
                    backslash-space-atpt
                    brace-space-atpt
                    bracket-space-atpt
                    dollar-space-atpt
                    doublequote-space-atpt
                    parentize-space-atpt
                    separate-space-atpt
                    singlequote-space-atpt
                    slash-space-atpt
                    string-greater-angle-atpt
                    string-lower-angle-atpt
                    backslash-string-atpt
                    brace-string-atpt
                    bracket-string-atpt
                    dollar-string-atpt
                    doublequote-string-atpt
                    parentize-string-atpt
                    separate-string-atpt
                    singlequote-string-atpt
                    slash-string-atpt
                    sh-struct-greater-angle-atpt
                    sh-struct-lower-angle-atpt
                    backslash-sh-struct-atpt
                    brace-sh-struct-atpt
                    bracket-sh-struct-atpt
                    dollar-sh-struct-atpt
                    doublequote-sh-struct-atpt
                    parentize-sh-struct-atpt
                    separate-sh-struct-atpt
                    singlequote-sh-struct-atpt
                    slash-sh-struct-atpt
                    symbol-greater-angle-atpt
                    symbol-lower-angle-atpt
                    backslash-symbol-atpt
                    brace-symbol-atpt
                    bracket-symbol-atpt
                    dollar-symbol-atpt
                    doublequote-symbol-atpt
                    parentize-symbol-atpt
                    separate-symbol-atpt
                    singlequote-symbol-atpt
                    slash-symbol-atpt
                    td-greater-angle-atpt
                    td-lower-angle-atpt
                    backslash-td-atpt
                    brace-td-atpt
                    bracket-td-atpt
                    dollar-td-atpt
                    doublequote-td-atpt
                    parentize-td-atpt
                    separate-td-atpt
                    singlequote-td-atpt
                    slash-td-atpt
                    unibyte-greater-angle-atpt
                    unibyte-lower-angle-atpt
                    backslash-unibyte-atpt
                    brace-unibyte-atpt
                    bracket-unibyte-atpt
                    dollar-unibyte-atpt
                    doublequote-unibyte-atpt
                    parentize-unibyte-atpt
                    separate-unibyte-atpt
                    singlequote-unibyte-atpt
                    slash-unibyte-atpt
                    upper-greater-angle-atpt
                    upper-lower-angle-atpt
                    backslash-upper-atpt
                    brace-upper-atpt
                    bracket-upper-atpt
                    dollar-upper-atpt
                    doublequote-upper-atpt
                    parentize-upper-atpt
                    separate-upper-atpt
                    singlequote-upper-atpt
                    slash-upper-atpt
                    url-greater-angle-atpt
                    url-lower-angle-atpt
                    backslash-url-atpt
                    brace-url-atpt
                    bracket-url-atpt
                    dollar-url-atpt
                    doublequote-url-atpt
                    parentize-url-atpt
                    separate-url-atpt
                    singlequote-url-atpt
                    slash-url-atpt
                    whitespace-greater-angle-atpt
                    whitespace-lower-angle-atpt
                    backslash-whitespace-atpt
                    brace-whitespace-atpt
                    bracket-whitespace-atpt
                    dollar-whitespace-atpt
                    doublequote-whitespace-atpt
                    parentize-whitespace-atpt
                    separate-whitespace-atpt
                    singlequote-whitespace-atpt
                    slash-whitespace-atpt
                    word-greater-angle-atpt
                    word-lower-angle-atpt
                    backslash-word-atpt
                    brace-word-atpt
                    bracket-word-atpt
                    dollar-word-atpt
                    doublequote-word-atpt
                    parentize-word-atpt
                    separate-word-atpt
                    singlequote-word-atpt
                    slash-word-atpt
                    xdigit-greater-angle-atpt
                    xdigit-lower-angle-atpt
                    backslash-xdigit-atpt
                    brace-xdigit-atpt
                    bracket-xdigit-atpt
                    dollar-xdigit-atpt
                    doublequote-xdigit-atpt
                    parentize-xdigit-atpt
                    separate-xdigit-atpt
                    singlequote-xdigit-atpt
                    slash-xdigit-atpt)))
    (dolist (elt fns-test)
      ;; (let* ((first (split-string (format "%s" elt) "-"))
      ;; (thing (car first)))
      (message "   %s" elt)
      (funcall elt)
      (sit-for th-delimtest-delay)))
  ;; (undo)
  )
(defun th-sorttest () 
  (interactive)
  (copy-function-atpt)
  (set-buffer (get-buffer-create "th-sorttest"))
  (erase-buffer) 
  (insert "(defun foo (&optional beg end) 
  \"Bla blub. \"
  (interactive \"\*\")
  (let ((beg (cond (beg beg)
		   ((region-exists-p)
		    (region-beginning))
		   (t (point-min)))) 
	(end (cond (end (copy-marker end))
		   ((region-exists-p)
		    (copy-marker (region-end)))
		   (t (copy-marker (point-max))))))
    (save-excursion
      (goto-char beg))
    (when (interactive-p) (message \"%s %s\" beg end))))")
  (mark-whole-buffer)
  (sort-word-atpt nil (point-min) (point-max))
  (goto-char (point-min))
  (insert "Buffer should be sorted wordwise below!")
  (newline 2) 
  (switch-to-buffer (current-buffer))) 


(provide 'thingatpt-utils-test)
;;; thingatpt-utils-test.el ends here
